#include <avr/io.h>
#include <util/delay.h>
#include <avr/sfr_defs.h>
#include "usart.h"
#include "lcd.h"

#define s_down bit_is_clear(PINB, 1) // Switch Up to B1
#define s_up bit_is_clear(PINB, 2)	

int main()
{

	uint8_t i; //Clasical loop varriable
	uint8_t packet[5],data=0;
	int update = 1;	// Update LCD
	char code[10] = { 0x10,0x20,0x30,0x40,0x50,0x60,0x70,0x80,0x90 }; // Code to send to Reciever
	char wait_msg[16] = "Waiting 4 Orders";

	char item[10][16]={"Tea","Coffee","porotta","Chappathi","Chicken Chilli", \
	"Veg Biriyani","Ch. Biriyani","Chicken Fry","Aloo Gobi","--End of Menu---"}; // Food items
	unsigned int select=0; // selecting current display for up/down
	unsigned int i_t = 0;
	unsigned int item_rcvd[10];
	unsigned int item_num[9]={ 0,0,0,0,0,0,0,0,0 } ; // No of items Ordered
	
	InitLCD(0x00);		// Initialise LCD without Uline and Blink
	DDRB = DDRB & 0xF9; // Set the pins Port B1 & B2
	
	//Initialize the USART with Baud rate = 2400bps
	USARTInit(207); // edited by Monster brain

	/*
	Get data from the remote Tx Station
	The data is the value of PORTC on Remote Tx Board
	So we will copy it to the PORTC of this board.
	*/
			LCDClear();
			LCDGotoXY(1,1);
			LCDWriteString("WHO System 1.0");
			LCDGotoXY(0,0);
		 	LCDWriteString(wait_msg);
	while(1)
	{

				if(update)
				 {
				 		LCDClear();
						_delay_ms(20);
						LCDGotoXY(0,0);
						LCDWriteString(item[item_rcvd[select]]);
						LCDGotoXY(14,0);
						LCDWriteInt(item_num[item_rcvd[select]], 2);
						LCDGotoXY(0,1);
						if(select+1 < i_t)
						{	
							LCDWriteString(item[item_rcvd[select+1]] );
							LCDGotoXY(14,1);
							LCDWriteInt(item_num[ item_rcvd[select+1] ], 2);
						}
						update = 0;
				 }
			
		if(s_down)
		{
			if(select < i_t-1)
				select += 1;
			update = 1;
		}
		if(s_down)
		{
			if(select>0)
				select -= 1;
			update = 1;
		}
		//Wait for a packet
		while(!UDataAvailable());
			if(UReadData()!='A') continue;
		while(!UDataAvailable());
			if(UReadData()!='A') continue;
		
		while(UDataAvailable()!=3);

		//Get the packet
		for(i=2;i<5;i++)
		{
			packet[i]=UReadData();
		}

		//Is it ok?
		if(packet[2]!=((uint8_t)~packet[3])) continue;

		if(packet[4]!='Z') continue;

		//The packet is ok
		data=packet[2];

		for(i=0;i<10;i++)
		{
			if((data & 0xF0) == code[i])
			{
				item_num[i] = data & 0xF0;
				if(item_num[i] > 0)
				{
					item_rcvd[i_t] = i;
					i_t += 1;
					update = 1;
				}
			}
		}
	}

}
